Build also packages for Debian in PPA's

Bug #188564 reported by David Jaša on 2008-02-03
812
This bug affects 143 people
Affects Status Importance Assigned to Milestone
Launchpad itself
Low
Unassigned

Bug Description

This could be nice way how to repay Debian for all packages we've just "synced" from them - build PPA packages also for Debian branches that meet package's dependencies and provide repositories with these packages.

Philippe Coval (rzr) wrote :

Yes this would be appreciated, specially for not common architectures :)

Ondrej Certik (ondrej-certik) wrote :

This would be really great. Do you need any help with setting this up? I think this would greatly improve the Debian packages, as people would start using it, the same way people use it for Ubuntu. So Ubuntu would benefit as well.

Damiano Dallatana (damidalla) wrote :

I really think that is a great possibility of showing Debian the great commitment of Canonical and *buntu community to giving back to Debian. I don't think it would be hard to implement - adding a Debian possibility to PPA building is no more difficult than adding a new Ubuntu release.

Arvind (arvindkhadri) wrote :

It can be done, but the problem is whether Debian community will accept it or not, they have got real high standards. the PPA's need to striclty adhere to DFSG.Those people really don't like the idea of taking back from Ubuntu, i know this as i have been closely associated with a Debian guy.

Ondrej Certik (ondrej-certik) wrote :

Arvind, that's not true, I am from the Debian community and majority if not all people I know take back from Ubuntu. And this Debian PPA would really, really help.

Damiano Dallatana (damidalla) wrote :

Well, I was following the eternal discussion about "Ubuntu is not giving back to Debian", and I really think that if Canonical makes a part of one of his best products - Launchpad PPAs - available to Debian community, well, it would be a great and symbolic step ahead.
As for Debian high standards, I think that a centralized place for publishing deb repositories should be a "better standard" - in terms of build control and packages quality - to the myriad of debian repositories around the web.
I am not a developer, but if we want to "keep an eye" on better quality once more, why not making an (optional) lintian check on deb packages on PPAs - giving the PPA owner the possibility of certifying (i repeat, optionally) the formal quality of the published packages.
It's not a proposal about forcing Debian use Launchpad or PPA, but about giving Debian developers a pool of servers where he can build his packages. If openSUSE gives that possibility ( http://en.opensuse.org/Build_Service/Deb_builds - even if it's without repositories), why do we have to show less commitment to Debian than openSuse does?

Sorry for the long post, I wanted to clearly give my two little cents.

Arvind (arvindkhadri) wrote :

@Ondrej :If thats the case, i would love to help in whatever ways i can.

Ondrej Certik (ondrej-certik) wrote :

Arvind: thanks, glad to hear it. :)

Damiano: yes, it be awesome, completely agree.

Changed in soyuz:
importance: Undecided → Low
status: New → Triaged

Like many have noted, it would be a nice way to give something back to Debian, but it's more than that. It would be very useful for Ubuntu itself, as many of us who work on Ubuntu maintain packages directly in Debian as well. It could be used as a tool for us to help get our packages sponsored, ect.... It also is giving upstreams that use LP another way to distribute their packages.

I can't imagine any technical problem with doing this. The only issues would be buildd machines and hosting space. Any word if this is being seriously considered?

Yes, we're looking at doing this! There's a few hurdles to overcome, but I hope we can take a more focused look towards the end of the year.

Hi, bump, any advances on this front ?

2009/4/14 Julian Edwards <email address hidden>

> Yes, we're looking at doing this! There's a few hurdles to overcome,
> but I hope we can take a more focused look towards the end of the year.
>
> --
> Build also packages for Debian in PPA's
> https://bugs.launchpad.net/bugs/188564
> You received this bug notification because you are a direct subscriber
> of the bug.
>

--
My Fingerprint:1024D/67CF3C40 :7C43 BB90 1E92 2E8D 647A 5DB0 DC64 0799 67CF
3C40
Arvind: https://launchpad.net/~arvindkhadri
The box said Windoze or better,so i installed Linux
http://techietipsandtricks.blogspot.com
http://xkcd.com/272/
Registered Linux User #46760
arvind_khadri (on irc.freenode.net)

Henning Eggers (henninge) wrote :

On behalf of: John Vivirito (https://bugs.launchpad.net/~gnomefreak)

I want this and love the idea. I have been thinking about
this for a while now and there is one problem i ran into.

Problem: sid stays untable/testing so all
packages get updates all the time. Is this a problem for
Soyuz to keep up with the packages? If not than we are
going to have a lot of failed builds

Celso Providelo (cprov) wrote :

No problem in keep up with new debian packages. We already import them regularly (2x day):

https://edge.launchpad.net/debian/+series

Thomas (t.c) wrote :

so it is possible to build packages for lenny in my ppa?
what I have to do?

only in my dput a new configuration section with

incoming = ~<lp_name>/ppa/ubuntu/lenny

???

Thomas, this is not possible yet, we have no build infrastructure for Debian builds. It will come at some point.

Rafael Belmonte (eaglescreen) wrote :

Hello i am a Debian enthusiast and I really think that this is the best gift that Canonical can offer to Debian.
I'm waiting for new about this improvement.

Lucas Nussbaum (lucas) wrote :

Hi,

Here is the procedure to generate Debian build chroots on amd64, for both amd64 and i386.

# for amd64
debootstrap --variant=buildd SUITE TARGETDIR http://localhost:9999/debian
# With SUITE=sid,squeeze,lenny
# example:
debootstrap --variant=buildd sid /tmp/sid-chroot http://localhost:9999/debian

# still on amd64, to generate i386 chroots:
debootstrap --variant=buildd --arch=i386 SUITE TARGETDIR http://localhost:9999/debian

Chroots for lenny, squeeze and sid are useful. If that's too much, you could drop the squeeze one. Most users of squeeze won't mind installing a few packages from sid if necessary.

There's no lpia architecture on Debian.

After that, the chroots can probably be managed the same way as the Ubuntu chroots.

Lucas Nussbaum (lucas) wrote :

Ah, and for the "squeeze" suite to work, you would need at least debootstrap 1.0.11.

Ondrej Certik (ondrej-certik) wrote :

Hi Lucas!

On Fri, Sep 11, 2009 at 2:21 PM, Lucas Nussbaum
<email address hidden> wrote:
> Hi,
>
> Here is the procedure to generate Debian build chroots on amd64, for
> both amd64 and i386.
>
> # for amd64
> debootstrap --variant=buildd SUITE TARGETDIR http://localhost:9999/debian
> # With SUITE=sid,squeeze,lenny
> # example:
> debootstrap --variant=buildd sid /tmp/sid-chroot http://localhost:9999/debian
>
> # still on amd64, to generate i386 chroots:
> debootstrap --variant=buildd --arch=i386 SUITE TARGETDIR http://localhost:9999/debian
>
> Chroots for lenny, squeeze and sid are useful. If that's too much, you
> could drop the squeeze one. Most users of squeeze won't mind installing
> a few packages from sid if necessary.
>
> There's no lpia architecture on Debian.
>
> After that, the chroots can probably be managed the same way as the
> Ubuntu chroots.

Thanks for this. Unfortunately I don't have time to work on this.

I hope someone can give it a shot.

Ondrej

Arvind (arvindkhadri) wrote :

Hi Lucas, am new to this, i have never maintained a chroot, could you point
me to where i can get more info about it.Also i have been building packages
for myself using checkinstall.I really want to help.
Thanks and regards.

2009/9/12 Ondrej Certik <email address hidden>

> Hi Lucas!
>
> On Fri, Sep 11, 2009 at 2:21 PM, Lucas Nussbaum
> <email address hidden> wrote:
> > Hi,
> >
> > Here is the procedure to generate Debian build chroots on amd64, for
> > both amd64 and i386.
> >
> > # for amd64
> > debootstrap --variant=buildd SUITE TARGETDIR
> http://localhost:9999/debian
> > # With SUITE=sid,squeeze,lenny
> > # example:
> > debootstrap --variant=buildd sid /tmp/sid-chroot
> http://localhost:9999/debian
> >
> > # still on amd64, to generate i386 chroots:
> > debootstrap --variant=buildd --arch=i386 SUITE TARGETDIR
> http://localhost:9999/debian
> >
> > Chroots for lenny, squeeze and sid are useful. If that's too much, you
> > could drop the squeeze one. Most users of squeeze won't mind installing
> > a few packages from sid if necessary.
> >
> > There's no lpia architecture on Debian.
> >
> > After that, the chroots can probably be managed the same way as the
> > Ubuntu chroots.
>
> Thanks for this. Unfortunately I don't have time to work on this.
>
> I hope someone can give it a shot.
>
> Ondrej
>
> --
> Build also packages for Debian in PPA's
> https://bugs.launchpad.net/bugs/188564
> You received this bug notification because you are a direct subscriber
> of the bug.
>

--
My Fingerprint:1024D/67CF3C40 :7C43 BB90 1E92 2E8D 647A 5DB0 DC64 0799 67CF
3C40
Arvind: https://launchpad.net/~arvindkhadri
The box said Windoze or better,so i installed Linux
http://techietipsandtricks.blogspot.com
http://xkcd.com/272/
Registered Linux User #46760
arvind_khadri (on irc.freenode.net)

Lucas Nussbaum (lucas) wrote :

On 12/09/09 at 03:56 -0000, Arvind wrote:
> Hi Lucas, am new to this, i have never maintained a chroot, could you point
> me to where i can get more info about it.Also i have been building packages
> for myself using checkinstall.I really want to help.
> Thanks and regards.

Well, the information I provided applied to the case where you want to
build your chroot manually for use with sbuild, for example.

In the general case, you should try to use pbuilder. It will be easy to
find documentation about it.
--
| Lucas Nussbaum
| <email address hidden> http://www.lucas-nussbaum.net/ |
| jabber: <email address hidden> GPG: 1024D/023B3F4F |

Arvind (arvindkhadri) wrote :

Oh ya i have heard abt it, will get stated about it asap.

2009/9/12 Lucas Nussbaum <email address hidden>

> On 12/09/09 at 03:56 -0000, Arvind wrote:
> > Hi Lucas, am new to this, i have never maintained a chroot, could you
> point
> > me to where i can get more info about it.Also i have been building
> packages
> > for myself using checkinstall.I really want to help.
> > Thanks and regards.
>
> Well, the information I provided applied to the case where you want to
> build your chroot manually for use with sbuild, for example.
>
> In the general case, you should try to use pbuilder. It will be easy to
> find documentation about it.
> --
> | Lucas Nussbaum
> | <email address hidden> http://www.lucas-nussbaum.net/ |
> | jabber: <email address hidden> GPG: 1024D/023B3F4F |
>
> --
> Build also packages for Debian in PPA's
> https://bugs.launchpad.net/bugs/188564
> You received this bug notification because you are a direct subscriber
> of the bug.
>

--
My Fingerprint:1024D/67CF3C40 :7C43 BB90 1E92 2E8D 647A 5DB0 DC64 0799 67CF
3C40
Arvind: https://launchpad.net/~arvindkhadri
The box said Windoze or better,so i installed Linux
http://techietipsandtricks.blogspot.com
http://xkcd.com/272/
Registered Linux User #46760
arvind_khadri (on irc.freenode.net)

John Vivirito (gnomefreak) wrote :

I'm getting the feeling we are a bit off topic with info on how to set up a build chroot/pbuilder/ect...
I have packaged a few things for Debian and they have been sponsored pushed to Sid IIRC.
To maintain packages from Ubuntu ---> Debian. The problem i see with not having a Debian buildds in PPAfor Debian as it is nice to have other people to test them since 1 person testing the packages isnt really enough to say "it works fine" or what not. We normally dont use our packages for Debian. i do because we are trying to get extensions from Ubuntu to Debian, as Debian doesnt have them and it was approved to start building extensions for the ones they dont already have. This week I just finished updating Flashgot for us, but we are pushing to Debian first and we sync from them.

I Debian buildd for PPA will allow Debian users to install packages and test and install from them.

Curtis Hovey (sinzui) on 2009-10-09
tags: added: tech-debt
tags: removed: tech-debt
Henning Pingel (henningpingel) wrote :

Hi,

I would really appreciate the possibility to build debian packages in PPAs. Is there any news about when it might be possible to do this?

Henning

Eric Hammond (esh) wrote :

I also would love to give back to and support the Debian community by making it easy for my Debian friends to use the software I am building. Not having this leaves a hole in my ability to support EC2 users.

Jan Dolinár (dolik-rce) wrote :

Hello,
Any news about this topic? Our project ( http://www.ultimatepp.org ) uses PPA to distribute packages to Ubuntu users. I would be great if we could offer the same convenient way for Debian users as well. At least for the most common architectures...

We would consider doing this but not as a direct upload to a Debian PPA, but rather a "check that your Ubuntu package will also build on Sid" capability. In other words, if folks upload to a PPA for the current Ubuntu development series, and the package builds successfully, we'd also build it against Sid.

PPA builds consume a great deal of resources and it's difficult justify spending that amount of money as a gift, especially if the net effect would be to encourage people to build packages which don't necessarily work with Ubuntu. But we can see the benefits of encouraging developers to factor both Ubuntu and Debian into their packaging efforts, so we're open to that.

While it may seem like little work, it's not something that is a priority and we have many, many other demands on the system. LP is open source, so this may be something that a person with the right motivation could contribute.

Jan Dolinár (dolik-rce) wrote :

Thanks for answer. Your proposed approach (build against Sid only if succesfully built on Ubuntu) seems good to me... Hope someone with enough motivation and time to implement this will emerge soon :-)

les (lesion) on 2010-11-10
description: updated
ibidem (ibid-ag) wrote :

Any progress on this?

j.c.sackett (jcsackett) on 2011-07-07
Changed in launchpad:
assignee: nobody → Huw Wilkins (huwshimi)
j.c.sackett (jcsackett) on 2011-07-07
Changed in launchpad:
assignee: Huw Wilkins (huwshimi) → nobody
ghstridr (ghstridr) wrote :

If someone can point me to documetation for setting up a buildbot for this type of thing, I will set up a virtual machine on my server for this.

Paul Tagliamonte (paultag) wrote :

Has anyone looked at this lately? I'd love to see this...

Rafael Belmonte (eaglescreen) wrote :

I think, the main reason because this is not being implemented is by resources (economical), more then a technical question.
Several machine servers are needed to build packages for Ubuntu's PPAs, and another couple of new machine servers would be necessary to start building also packages for Debian in PPAs.

Philipp Kern (pkern) wrote :

On Wed, Sep 14, 2011 at 09:08:12PM -0000, Rafael Belmonte wrote:
> I think, the main reason because this is not being implemented is by
> resources (economical), more then a technical question.
> Several machine servers are needed to build packages for Ubuntu's
> PPAs, and another couple of new machine servers would be necessary
> to start building also packages for Debian in PPAs.

I guess you mean sysadmin and engineer time, certainly not servers? I
don't necessarily buy that argument. You could also start them with
low priority on the existing farm to begin with.

It's a bit sad that the architecture doesn't really allow 3rd party
builders unless you're a Canonical employee. Otherwise the community
could just help with a bunch of servers, if that's really the problem
you're facing.

Kind regards
Philipp Kern

Micah Gersten (micahg) wrote :

There's nothing for the Ubuntu project to do with this, so changing to a null bug task.

affects: ubuntu → null
Changed in null:
status: New → Invalid
Curtis Hovey (sinzui) on 2011-11-11
no longer affects: null
shawnlandden (shawnlandden) wrote :

Why isn't this being implamented?

Hadrien Dussuel (dbkblk) wrote :

Let's hope they change theirs minds...

Mike Mestnik (cheako) wrote :

This is something that would be vary valuable to Debian users. There is currently a project like launchpad PPA for Debian and there is also mentors.debian.net that does not build packages, only publishes the source.

DFSG have nothing to do with 3rd party repositories, being that's what PPA is. I'm amassed that Canonical will host packages for any one, they might be distributing copyrighted or otherwise illegal material.

I don't see launchpad PPA being a good alternative to mentors.debian.net, posting packages to a launchpad PPA would be a distribution portal, not an advertisement for inclusion, much as it is for Ubuntu.

I don't see where the problem exists with spending computer resources on this, your boxes are either doing something or they are idle. Spending idle time on this would be appreciated more then setiathome!

What about the possibility of uploading compiled packages for Debian distributions?

Mike Mestnik (cheako) wrote :

What about as a compromise allowing source and precompiled packages for Debian to be uploaded?

Alba Nader (sharepass12) wrote :

Yes, this would be awesome!

66Ton99 (66ton99) wrote :

Any news or progress?

Laura Czajkowski (czajkowski) wrote :

@66Ton99 Hi, currently we are working on fixing bugs market critical first before we move onto bugs other triaged categories such as High and then Low.

Todd Vierling (duh) wrote :

As a possible middle ground, it would be nice to be able to build a package within a PPA for a Debian _released_ version (not sid), for a source package that is also built for at least one Ubuntu release version within the same PPA.

Thiago Martins (martinx) wrote :

Hey guys!

Launchpad did a great progress this year (2015)! I mean, with the inclusion of Git support:

http://blog.launchpad.net/general/git-code-hosting-beta

https://help.launchpad.net/Code/Git

Now, I think that next step will be to add support for Debian PPA (Sid, Jessie, Wheezy, etc) in Launchpad!

I work with both Debian and Ubuntu, so, a "Debian PPA" in Launchpad is something that I'm expecting to see for a long time.

It is a pain to maintain building and hosting servers for my Debian packages, not to mention GPG keys and etc... I prefer to move to Launchpad Debian PPA instead...

Please Canonical, do this!! Add Debian PPA into Launchpad! That would be AWESOME!!

Cheers!
Thiago

ProfessorKaos64 (mdeguzis) wrote :

Thanks Thiago, I would love to be able to use Launchpad with Debian packages.

Michael (stapelberg) wrote :

Agreed — I’m also looking for a way to store Debian packages (for sid) on launchpad. I don’t even need launchpad to build them, just to accept and serve them :). That way, I could host Debian and Ubuntu packages on the same infrastructure.

Simon Müller (msimon) wrote :

Opting in for having my packages also build for some debian releases.

Just a reminder - any progress on this issue.
I think after 9 years this issue should be decided to be "INVALID" or put some effort in it.

To make clear: I also found the possibility to build debian packages in launchpad a valuable service.
It would help to minimize the gap between these wonderful 2 distributions.

As noted in comment #6 the open build service from opensuse also supports beneath other distribution ubuntu and debian.
I'm not suggesting that launchpad should compete with this, but I think it should be opened up for relative distributions of the 'debian' family.

Marcin Krol (hawq) wrote :

It would be great to add support for Debian PPAs to Launchpad. I was looking today for information if its already possible to build Debian packages using PPAs and after seeing https://launchpad.net/debian/+ppas I thought it is, but unfortunately it isn't.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Related questions